AnnotationDefaultAttribute (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.lang.classfile.attribute, interface: AnnotationDefaultAttribute
Keywords: java.lang.classfile.attribute.AnnotationDefaultAttribute interface

# Interface AnnotationDefaultAttribute

All Superinterfaces:
  `Attribute<AnnotationDefaultAttribute>, ClassFileElement, MethodElement`

public sealed interface AnnotationDefaultAttribute extends Attribute<AnnotationDefaultAttribute>, MethodElement
Models the `AnnotationDefault` attribute (JVMS 4.7.22), which records the default value (JLS 9.6.2) for the annotation interface element defined by this method.

This attribute only appears on methods, and does not permit multiple instances in a method. It has a data dependency on the constant pool.

This attribute was introduced in the Java SE Platform version 5.0, major version 49.

See Java Language Specification:
  9.6.2 Defaults for Annotation Interface Elements
See Java Virtual Machine Specification:
  4.7.22 The `AnnotationDefault` Attribute
Since:
  24
See Also:
  - `Attributes.annotationDefault()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `AnnotationValue`
  `defaultValue()`
  Returns the default value of the annotation interface element defined by the enclosing method.
  `static AnnotationDefaultAttribute`
  `of(AnnotationValue annotationDefault)`
  Returns an `AnnotationDefault` attribute.

  ### Methods declared in interface Attribute

  `attributeMapper, attributeName`
  Modifier and Type
  Method
  Description
  `AttributeMapper<AnnotationDefaultAttribute>`
  `attributeMapper()`
  Returns the `AttributeMapper` associated with this attribute.
  `Utf8Entry`
  `attributeName()`
  Returns the name of the attribute.

- ## Method Details

  - ### defaultValue

    AnnotationValue defaultValue()
    Returns the default value of the annotation interface element defined by the enclosing method.
    Returns:
      the default value of the annotation interface element defined by the enclosing method
    See Also:
      - `Method.getDefaultValue()`

  - ### of

    static AnnotationDefaultAttribute of(AnnotationValue annotationDefault)
    Returns an `AnnotationDefault` attribute.
    Parameters:
      `annotationDefault` - the default value of the annotation interface element
    Returns:
      an `AnnotationDefault` attribute